#include "stc.h"
#include "can.h"
#include "iap.h"
#include "dfu.h"

DWORD xdata DfuFlag _at_ 0x1ffc;

static void delay()
{
    int i;
    
    for (i = 0; i < 5000; i++);
}

void dfu_check()
{
    P3M1 &= ~0x08;
    P3PU |= 0x08;
    _nop_();
    _nop_();
    _nop_();
    _nop_();
    delay();
    
    if ((DFU_FORCEPIN != 0) &&
        (DfuFlag != DFU_TAG) &&
        (*(BYTE code *)(LDR_SIZE) == 0x02) &&
        (*(WORD code *)(LDR_SIZE + 1) >= LDR_SIZE + 3))
    {
        P3M1 |= 0x08;
        P3PU = 0x00;
        ((void (far *)())(0xff0000 + LDR_SIZE))();
    }
    
    P3M1 |= 0x08;
    P3PU = 0x00;
    DfuFlag = 0;
}


void dfu_events()
{
    BYTE n,i,sr;
    DWORD addr;

    if (!bCanRxReady)
        return;

    n = CanReadMsg(CAN1_Rx);    //ȡ
    if(n>0)
    {
        for(i=0;i<n;i++)
        {
            if(CAN1_Rx[i].ID == DFU_CMD_CONNECT)  //
            {
                sr = CanReadReg(SR);
                if(sr & 0x01)		//жǷ BS:BUS-OFF״̬
                {
                    CANAR = MR;
                    CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
                }
                CAN1_Tx.DLC = 0x00;         //ݳ
                CAN1_Tx.ID = REP_CMD_CONNECT; //CAN ID
                CanSendMsg(&CAN1_Tx);   //͡׼ɡӦ
#ifdef DEBUG
                printf("ISP Read:ID=0x%08lX DLC=%d\r\n",CAN1_Rx[i].ID,CAN1_Rx[i].DLC);   //ڴӡ֡Ϣ
#endif
                break;
            }
            else if(CAN1_Rx[i].ID == DFU_CMD_ERASE) //
            {
#ifdef DEBUG
                printf("ISP Read:ID=0x%08lX DLC=%d\r\n",CAN1_Rx[i].ID,CAN1_Rx[i].DLC);   //ڴӡ֡Ϣ
#endif
                addr = 0;
                while (addr < 0x20000)
                {
                    iap_erase_page(addr);
                    addr += 0x200;
                }
                sr = CanReadReg(SR);
                if(sr & 0x01)		//жǷ BS:BUS-OFF״̬
                {
                    CANAR = MR;
                    CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
                }
                CAN1_Tx.DLC = 0x00;         //ݳ
                CAN1_Tx.ID = REP_CMD_ERASE; //CAN ID
                CanSendMsg(&CAN1_Tx);   //͡׼ɡӦ
#ifdef DEBUG
                printf("ISP Respond:ID=0x%08lX\r\n",CAN1_Tx.ID);   //ڴӡ֡Ϣ
#endif
                break;
            }
            else if((CAN1_Rx[i].ID&~0x1ffff) == DFU_CMD_PROGRAM) //ݴ
            {
#ifdef DEBUG
                printf("ISP Read:ID=0x%08lX DLC=%d ",CAN1_Rx[i].ID&0x1ffff,CAN1_Rx[i].DLC);   //ڴӡ֡Ϣ
#endif
                for(addr=0;addr<CAN1_Rx[i].DLC;addr++)
                {
                    iap_write_byte((CAN1_Rx[i].ID&0x1ffff)+addr, CAN1_Rx[i].DataBuffer[addr]);
#ifdef DEBUG
                    printf("0x%02X ",CAN1_Rx[i].DataBuffer[addr]);
#endif
                }
#ifdef DEBUG
                printf("\r\n");
#endif
            }
            else if(CAN1_Rx[i].ID == DFU_CMD_REBOOT) //λ
            {
#ifdef DEBUG
                printf("ISP Read::ID=0x%08lX DLC=%d\r\n",CAN1_Rx[i].ID,CAN1_Rx[i].DLC);   //ڴӡ֡Ϣ
#endif
                sr = CanReadReg(SR);
                if(sr & 0x01)		//жǷ BS:BUS-OFF״̬
                {
                    CANAR = MR;
                    CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
                }
                CAN1_Tx.DLC = 0x00;         //ݳ
                CAN1_Tx.ID = REP_CMD_REBOOT; //CAN ID
                CanSendMsg(&CAN1_Tx);   //͡׼ɡӦ

                delay();
                IAP_CONTR = 0x20;   //
                while (1);
            }
        }
    }
    bCanRxReady = 0;
}
