#ifndef __UART_H__
#define __UART_H__

//========================================================================
//                              
//========================================================================

#define	CAN1	0
#define	CAN2	1

#define	STANDARD_FRAME   0  //֡ʽ׼֡
#define	EXTENDED_FRAME   1  //֡ʽչ֡

#define	DUAL_FILTER      0  //˫˲
#define	SINGLE_FILTER    1  //˲

//========================================================================
//                              
//========================================================================

#define CAN_DOIM     0x01  //ж
#define CAN_BEIM     0x02  //ߴλж
#define CAN_TIM      0x04  //ж
#define CAN_RIM      0x08  //ж
#define CAN_EPIM     0x10  //λж
#define CAN_EWIM     0x20  //λж
#define CAN_ALIM     0x40  //ٲöʧж
#define CAN_ALLIM    0x7F  //ж

//========================================================================
//                              
//========================================================================

typedef struct
{
	BYTE	CAN_Enable;     //CANʹ  	ENABLE,DISABLE
	BYTE	CAN_IMR;        //CANжϼĴ 	CAN_DOIM,CAN_BEIM,CAN_TIM,CAN_RIM,CAN_EPIM,CAN_EWIM,CAN_ALIM,CAN_ALLIM,DISABLE
	BYTE	CAN_SJW;        //ͬԾ  0~3
	BYTE	CAN_BRP;        //ʷƵϵ    0~63
	BYTE	CAN_SAM;        //ߵƽ  0:1; 1:3
	BYTE	CAN_TSG1;       //ͬ1       0~15
	BYTE	CAN_TSG2;       //ͬ2       1~7 (TSG2 Ϊ0)
	BYTE	CAN_ListenOnly; //Listen Onlyģʽ   ENABLE,DISABLE
	BYTE	CAN_Filter;     //˲ѡ    DUAL_FILTER(˫˲),SINGLE_FILTER(˲)

	BYTE	CAN_ACR0;       //մĴ 0~0xFF
	BYTE	CAN_ACR1;       //մĴ 0~0xFF
	BYTE	CAN_ACR2;       //մĴ 0~0xFF
	BYTE	CAN_ACR3;       //մĴ 0~0xFF
	BYTE	CAN_AMR0;       //μĴ 0~0xFF
	BYTE	CAN_AMR1;       //μĴ 0~0xFF
	BYTE	CAN_AMR2;       //μĴ 0~0xFF
	BYTE	CAN_AMR3;       //μĴ 0~0xFF
}edata CAN_InitTypeDef;

typedef struct
{
	BYTE	DLC:4;          //ݳ, bit0~bit3
	BYTE	:2;             //, bit4~bit5
	BYTE	RTR:1;          //֡, bit6
	BYTE	FF:1;           //֡ʽ, bit7
	DWORD	ID;             //CAN ID
	BYTE	DataBuffer[8];  //ݻ
}edata CAN_DataDef;

//========================================================================
//                              ⲿ
//========================================================================
extern bit B_Can1Send;     //CAN1 ɱ־
extern bit B_Can2Send;     //CAN2 ɱ־
extern bit B_Can1Read;     //CAN յݱ־
extern bit B_Can2Read;     //CAN յݱ־

extern CAN_DataDef CAN1_Tx;
extern CAN_DataDef CAN1_Rx[8];
extern CAN_DataDef CAN2_Tx;
extern CAN_DataDef CAN2_Rx[8];


void can_init();
BYTE CanReadReg(BYTE addr);
BYTE CanReadMsg(CAN_DataDef *CAN);
void CanSendMsg(CAN_DataDef *CAN);




//void uart_init();
void can_isr();

extern BOOL bCanRxReady;

//extern BYTE edata UartTxBuffer[256];
//extern BYTE edata UartRxBuffer[256];

//void can_send(BYTE status, BYTE size);

#endif
