#include "stc.h"
#include "usb.h"
#include "iap.h"
#include "util.h"
#include "dfu.h"
#include "can.h"

DWORD xdata DfuFlag _at_ 0x1ffc;

void delay_ms(WORD ms)
{
    WORD i;
    do{
        i = FOSC / 6000;
        while(--i);   //6T per loop
    }while(--ms);
}

void dfu_events()
{
    BYTE i,n;
    BYTE cmd;
    DWORD addr;
    BYTE size;
    BYTE *ptr;
    BYTE status;

    if (!bUsbOutReady)
        return;

    status = STATUS_ERRORWRAP;
    if ((UsbOutBuffer[0] == '#') &&
        (UsbOutBuffer[62] == '$') &&
        (chksum(UsbOutBuffer, 64) == 0))
    {
        cmd = UsbOutBuffer[1];
        addr = *(DWORD *)&UsbOutBuffer[2] & 0x1ffff;
        size = UsbOutBuffer[6];
        ptr = &UsbOutBuffer[7];
        status = STATUS_OK;
        
        memset(UsbInBuffer, 0, 64);

        if(bCanRxReady)     //жCANǷյ
        {
            bCanRxReady = 0;    //յӦ
            n = CanReadMsg(CAN1_Rx);    //ȡջ
        }

        switch (cmd)
        {
        case DFU_CMD_CONNECT:
            UsbInBuffer[2] = 2;
            UsbInBuffer[3] = LDR_VERSION >> 8;
            UsbInBuffer[4] = LDR_VERSION;

            bCanRxReady = 0;
            CAN1_Tx.DLC = 0x00;             //ݳ
            CAN1_Tx.ID = CAN_CMD_CONNECT;   //CAN ID

            i = 0;
            status = STATUS_ERRORWRAP;
            while((status == STATUS_ERRORWRAP) && (i<20))
            {
                CanSendMsg(&CAN1_Tx);        //ĿоƬź
                i++;
                delay_ms(10);
#ifdef DEBUG
                printf("Send CMD_CONNECT,bCanRxReady=%d.\r\n",bCanRxReady);   //ڴӡ֡Ϣ
#endif
                if(bCanRxReady)
                {
                    bCanRxReady = 0;    //յӦ

                    n = CanReadMsg(CAN1_Rx);    //ȡ
                    if(n>0)
                    {
                        for(i=0;i<n;i++)
                        {
#ifdef DEBUG
                            printf("Tool Read:ID=0x%08lX\r\n",CAN1_Rx[i].ID);   //ڴӡ֡Ϣ
#endif
                            if(CAN1_Rx[i].ID == REP_CMD_CONNECT)  //
                            {
                                status = STATUS_OK;
                                break;
                            }
                        }
                    }
                }
            }
            break;
        case DFU_CMD_ERASE:
            bCanRxReady = 0;
            CAN1_Tx.DLC = 0x00;         //ݳ
            CAN1_Tx.ID = CAN_CMD_ERASE; //CAN ID

            i = 0;
            status = STATUS_ERRORWRAP;
            while((status == STATUS_ERRORWRAP) && (i<3))
            {
                CanSendMsg(&CAN1_Tx);        //ĿоƬͲź
                i++;
                delay_ms(1500);
#ifdef DEBUG
                printf("Send CMD_ERASE,bCanRxReady=%d.\r\n",bCanRxReady);   //ڴӡ֡Ϣ
#endif
                if(bCanRxReady)
                {
                    bCanRxReady = 0;    //յӦ

                    n = CanReadMsg(CAN1_Rx);    //ȡ
                    if(n>0)
                    {
                        for(i=0;i<n;i++)
                        {
#ifdef DEBUG
                            printf("Tool Read:ID=0x%08lX\r\n",CAN1_Rx[i].ID);   //ڴӡ֡Ϣ
#endif
                            if(CAN1_Rx[i].ID == REP_CMD_ERASE)  //
                            {
                                status = STATUS_OK;
                                break;
                            }
                        }
                    }
                }
            }
            break;
        case DFU_CMD_READ:
            status = STATUS_ERRORCMD;
            break;
        case DFU_CMD_PROGRAM:
            if (size > 55)
            {
                status = STATUS_OUTOFRANGE;
            }
            else
            {
                while (size)
                {
                    if(size >= 8)
                    {
                        CAN1_Tx.ID = CAN_CMD_PROGRAM + addr;
                        CAN1_Tx.DLC = 0x08;
#ifdef DEBUG
                        printf("Tool Read:ID=0x%08lX DLC=%d ",CAN1_Tx.ID,CAN1_Tx.DLC);   //ڴӡ֡Ϣ
#endif
                        for(i=0;i<8;i++)
                        {
                            CAN1_Tx.DataBuffer[i] = *ptr++;
#ifdef DEBUG
                            printf("0x%02X ",CAN1_Tx.DataBuffer[i]);
#endif
                        }
#ifdef DEBUG
                        printf("\r\n");
#endif
                        CanSendMsg(&CAN1_Tx);
                        addr += 8;
                        size -= 8;
                    }
                    else
                    {
                        CAN1_Tx.ID = CAN_CMD_PROGRAM + addr;
                        CAN1_Tx.DLC = size;
#ifdef DEBUG
                        printf("Tool Read:ID=0x%08lX DLC=%d ",CAN1_Tx.ID,CAN1_Tx.DLC);   //ڴӡ֡Ϣ
#endif
                        for(i=0;i<size;i++)
                        {
                            CAN1_Tx.DataBuffer[i] = *ptr++;
#ifdef DEBUG
                            printf("0x%02X ",CAN1_Tx.DataBuffer[i]);
#endif
                        }
#ifdef DEBUG
                        printf("\r\n");
#endif
                        CanSendMsg(&CAN1_Tx); 
                        addr += size;
                        size = 0;
                    }
                    delay_ms(5);
                }
            }
            break;
        case DFU_CMD_REBOOT:
            usb_OUT_done();

            bCanRxReady = 0;
            CAN1_Tx.DLC = 0x00;             //ݳ
            CAN1_Tx.ID = CAN_CMD_REBOOT;   //CAN ID

            i = 0;
            status = STATUS_ERRORWRAP;
            while((status == STATUS_ERRORWRAP) && (i<20))
            {
                CanSendMsg(&CAN1_Tx);        //ĿоƬź
                i++;
                delay_ms(10);
#ifdef DEBUG
                printf("Send CMD_REBOOT,bCanRxReady=%d.\r\n",bCanRxReady);   //ڴӡ֡Ϣ
#endif
                if(bCanRxReady)
                {
                    bCanRxReady = 0;    //յӦ

                    n = CanReadMsg(CAN1_Rx);    //ȡ
                    if(n>0)
                    {
                        for(i=0;i<n;i++)
                        {
#ifdef DEBUG
                            printf("Tool Read:ID=0x%08lX\r\n",CAN1_Rx[i].ID);   //ڴӡ֡Ϣ
#endif
                            if(CAN1_Rx[i].ID == REP_CMD_REBOOT)  //
                            {
                                status = STATUS_OK;
                                break;
                            }
                        }
                    }
                }
            }
            break;
        default:
            status = STATUS_ERRORCMD;
            break;
        }
    }

    if (status == STATUS_ERRORWRAP)
    {
        if (USER_STCISPCMD != NULL)
        {
            if (strcmp(UsbOutBuffer, USER_STCISPCMD) == 0)
            {
                usb_write_reg(OUTCSR1, 0);
#ifdef DEBUG
                printf("Tool Reset:STATUS_ERRORWRAP\r\n");   //ڴӡϢ
#endif
                USBCON = 0x00;
                USBCLK = 0x00;
                IRC48MCR = 0x00;
                
                delay_ms(10);
                
                IAP_CONTR = 0x60;
                while (1);
            }
        }
    }
    else
    {
        UsbInBuffer[0] = '@';
        UsbInBuffer[1] = status;
        UsbInBuffer[62] = '$';
        UsbInBuffer[63] = -chksum(UsbInBuffer, 63);
        
        usb_IN();
    }
    
    usb_OUT_done();
}
