#include "stc.h"
#include "usb.h"
#include "iap.h"
#include "dfu.h"
#include "can.h"

void sys_init();
void UartInit(void);

char *USER_STCISPCMD = "@STCISP#";                      //ԶλISPûӿ

void main()
{
    sys_init();
    usb_init();
    can_init();
    iap_init();
#ifdef DEBUG
    UartInit();
#endif
    EUSB = 1;   //IE2صжʹܺҪEUSB
    EA = 1;     //ж
    
    while (1)
    {
        dfu_events();
    }
}

void sys_init()
{
    WTST = 0x00;
    CKCON = 0x00;
    EAXFR = 1;

    P3M0 &= ~0x03;
    P3M1 |= 0x03;
    
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    
    IRC48MCR = 0x80;
    while (!(IRC48MCR & 0x01));
}

#ifdef DEBUG
/******************** ڴӡ ********************/
void UartInit(void)
{
	P_SW1 = (P_SW1 & 0x3f) | 0x80;    //USART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7, 0xC0: P4.3 P4.4
	SCON = (SCON & 0x3f) | 0x40; 
	T1x12 = 1;          //ʱʱ1Tģʽ
	S1BRT = 0;          //1ѡʱ1Ϊʷ
	TL1 = BAUD;
	TH1 = BAUD>>8;
	TR1 = 1;			//ʱ1ʼʱ
}

void UartPutc(unsigned char dat)
{
	SBUF = dat; 
	while(TI==0);
	TI = 0;
}

char putchar(char c)
{
	UartPutc(c);
	return c;
}
#endif
